// AI_ReadValueDlg.cpp : implementation file
//

#include "stdafx.h"
#include "AI_ReadValue.h"
#include "AI_ReadValueDlg.h"
#include "..\..\..\Includes\ICPDAS_USBIO.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

ICPDAS_USBIO USBIO;
BYTE m_byDITotal;
BYTE m_byDOTotal;
BYTE m_byAITotal;
BYTE m_byAOTotal;
BYTE m_byPITotal;
BYTE m_byPOTotal;

/////////////////////////////////////////////////////////////////////////////
// CAI_ReadValueDlg dialog

CAI_ReadValueDlg::CAI_ReadValueDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAI_ReadValueDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAI_ReadValueDlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAI_ReadValueDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAI_ReadValueDlg)
	DDX_Control(pDX, IDC_TXTBOARDID, m_txtBID);
	DDX_Control(pDX, IDC_LBINFORMATION, m_lbModuleInfo);
	DDX_Control(pDX, IDC_LBDIGIVALUE, m_lbDigiValue);
	DDX_Control(pDX, IDC_LBCHSTA, m_lbChStatus);
	DDX_Control(pDX, IDC_LBANAVALUE, m_lbAnalogValue);
	DDX_Control(pDX, IDC_CBXDEVID, m_cbxDID);
	DDX_Control(pDX, IDC_BTNREADDIGIVALUEWITHCHSTA, m_btnReadDigitalValueWithChSta);
	DDX_Control(pDX, IDC_BTNREADDIGIVALUE, m_btnReadDigitalValue);
	DDX_Control(pDX, IDC_BTNREADANAVALUEWITHCHSTA, m_btnReadAnalogValueWithChSta);
	DDX_Control(pDX, IDC_BTNREADANAVALUE, m_btnReadAnalogValue);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAI_ReadValueDlg, CDialog)
	//{{AFX_MSG_MAP(CAI_ReadValueDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTNOPEN, OnBtnopendevice)
	ON_BN_CLICKED(IDC_BTNCLOSE, OnBtnclosedevice)
	ON_BN_CLICKED(IDC_BTNREADDIGIVALUE, OnBtnreaddigivalue)
	ON_BN_CLICKED(IDC_BTNREADANAVALUE, OnBtnreadanavalue)
	ON_BN_CLICKED(IDC_BTNREADDIGIVALUEWITHCHSTA, OnBtnreaddigivaluewithchsta)
	ON_BN_CLICKED(IDC_BTNREADANAVALUEWITHCHSTA, OnBtnreadanavaluewithchsta)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAI_ReadValueDlg message handlers

BOOL CAI_ReadValueDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
  m_txtBID.SetWindowText("1");
  m_cbxDID.SetCurSel(0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CAI_ReadValueDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CAI_ReadValueDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CAI_ReadValueDlg::OnBtnopendevice() 
{
  CString szBID;
  DWORD dwBID;
  int iSelIdx;
  int iErrCode;
  
  m_txtBID.GetWindowText(szBID);
  dwBID = _tcstoul(szBID, NULL, 10);
  
  iSelIdx = m_cbxDID.GetCurSel();
  
  USBIO.SetCommTimeout(500);
  if(ERR_NO_ERR != (iErrCode = USBIO.OpenDevice(USBIO_MINPID+iSelIdx+19, (BYTE)dwBID)))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    DWORD dwSoftWDTTimeout;
    WORD wFWVer;
    BYTE byDeviceSN[USBIO_SN_LENGTH];
    BYTE byDeviceNickName[USBIO_NICKNAME_LENGTH];
    BYTE bySupIOMask;
    int iIdx;
    
    USBIO.GetSoftWDTTimeout(&dwSoftWDTTimeout);
    sprintf(szItemString, "SoftWDT: %d", dwSoftWDTTimeout);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetFwVer(&wFWVer);
    sprintf(szItemString, "Version: %d", wFWVer);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceNickName(byDeviceNickName);
    sprintf(szItemString, "Description: ");
    for(iIdx = 0; iIdx < USBIO_NICKNAME_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%c", byDeviceNickName[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetDeviceSN(byDeviceSN);
    sprintf(szItemString, "SN: ");
    for(iIdx = 0; iIdx < USBIO_SN_LENGTH; iIdx++)
      sprintf(szItemString + strlen(szItemString), "%C", byDeviceSN[iIdx]);
    m_lbModuleInfo.AddString(szItemString);
    
    USBIO.GetSupportIOMask(&bySupIOMask);
    sprintf(szItemString, "Support IO Mask: 0x%02X", bySupIOMask);
    m_lbModuleInfo.AddString(szItemString);
    
    if(SUPPORT_DI(bySupIOMask))
    {
      USBIO.GetDITotal(&m_byDITotal);
      sprintf(szItemString, "DI channels: %d", m_byDITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_DO(bySupIOMask))
    {
      USBIO.GetDITotal(&m_byDOTotal);
      sprintf(szItemString, "DO channels: %d", m_byDOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AI(bySupIOMask))
    {
      USBIO.GetAITotal(&m_byAITotal);
      sprintf(szItemString, "AI channels: %d", m_byAITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_AO(bySupIOMask))
    {
      USBIO.GetAOTotal(&m_byAOTotal);
      sprintf(szItemString, "AO channels: %d", m_byAOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PI(bySupIOMask))
    {
      USBIO.GetPITotal(&m_byPITotal);
      sprintf(szItemString, "PI channels: %d", m_byPITotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    if(SUPPORT_PO(bySupIOMask))
    {
      USBIO.GetPOTotal(&m_byPOTotal);
      sprintf(szItemString, "PO channels: %d", m_byPOTotal);
      m_lbModuleInfo.AddString(szItemString);
    }
    
    m_btnReadDigitalValue.EnableWindow(TRUE);
    m_btnReadDigitalValueWithChSta.EnableWindow(TRUE);
    m_btnReadAnalogValue.EnableWindow(TRUE);
    m_btnReadAnalogValueWithChSta.EnableWindow(TRUE);
  }
}

void CAI_ReadValueDlg::OnBtnclosedevice() 
{
  int iErrCode;
  
  if(ERR_NO_ERR != (iErrCode = USBIO.CloseDevice()))
  {
    char szMessage[10];
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  
  m_btnReadDigitalValue.EnableWindow(FALSE);
  m_btnReadDigitalValueWithChSta.EnableWindow(FALSE);
  m_btnReadAnalogValue.EnableWindow(FALSE);
  m_btnReadAnalogValueWithChSta.EnableWindow(FALSE);
  
  m_lbModuleInfo.ResetContent();
  m_lbDigiValue.ResetContent();
  m_lbAnalogValue.ResetContent();
  m_lbChStatus.ResetContent();
}

void CAI_ReadValueDlg::OnBtnreaddigivalue() 
{
  int iErrCode;
  DWORD dwAIValue[USBIO_AI_MAX_CHANNEL];
  char szMessage[300];
  
  m_lbDigiValue.ResetContent();
  m_lbAnalogValue.ResetContent();
  m_lbChStatus.ResetContent();
  
  if(ERR_NO_ERR != (iErrCode = USBIO.AI_ReadValue(dwAIValue)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    int iIdx;
    
    for(iIdx = 0; iIdx < m_byAITotal; iIdx++)
    {
      sprintf(szItemString, "Ch%d : 0x%08x", iIdx, dwAIValue[iIdx]);
      
      m_lbDigiValue.AddString(szItemString);
    }
  }
}

void CAI_ReadValueDlg::OnBtnreadanavalue() 
{
  int iErrCode;
  float fAIValue[USBIO_AI_MAX_CHANNEL];
  char szMessage[300];
  
  m_lbDigiValue.ResetContent();
  m_lbAnalogValue.ResetContent();
  m_lbChStatus.ResetContent();
  
  if(ERR_NO_ERR != (iErrCode = USBIO.AI_ReadValue(fAIValue)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    int iIdx;
    
    for(iIdx = 0; iIdx < m_byAITotal; iIdx++)
    {
      sprintf(szItemString, "Ch%d : %f", iIdx, fAIValue[iIdx]);
      
      m_lbAnalogValue.AddString(szItemString);
    }
  }
}

void CAI_ReadValueDlg::OnBtnreaddigivaluewithchsta() 
{
  int iErrCode;
  DWORD dwAIValue[USBIO_AI_MAX_CHANNEL];
  BYTE byAIChStatus[USBIO_AI_MAX_CHANNEL];
  char szMessage[300];
  
  m_lbDigiValue.ResetContent();
  m_lbAnalogValue.ResetContent();
  m_lbChStatus.ResetContent();
  
  if(ERR_NO_ERR != (iErrCode = USBIO.AI_ReadValue(dwAIValue, byAIChStatus)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    int iIdx;
    
    for(iIdx = 0; iIdx < m_byAITotal; iIdx++)
    {
      sprintf(szItemString, "Ch%d : 0x%08x", iIdx, dwAIValue[iIdx]);
      
      m_lbDigiValue.AddString(szItemString);
      
      sprintf(szItemString, "Ch%d : 0x%02x", iIdx, byAIChStatus[iIdx]);
      
      m_lbChStatus.AddString(szItemString);
    }
  }
}

void CAI_ReadValueDlg::OnBtnreadanavaluewithchsta() 
{
  int iErrCode;
  float fAIValue[USBIO_AI_MAX_CHANNEL];
  BYTE byAIChStatus[USBIO_AI_MAX_CHANNEL];
  char szMessage[300];
  
  m_lbDigiValue.ResetContent();
  m_lbAnalogValue.ResetContent();
  m_lbChStatus.ResetContent();
  
  if(ERR_NO_ERR != (iErrCode = USBIO.AI_ReadValue(fAIValue, byAIChStatus)))
  {
    sprintf(szMessage, "[%d]", iErrCode);
    
    MessageBox(szMessage, "Error", MB_ICONERROR | MB_OK);
  }
  else
  {
    char szItemString[200];
    int iIdx;
    
    for(iIdx = 0; iIdx < m_byAITotal; iIdx++)
    {
      sprintf(szItemString, "Ch%d : %f", iIdx, fAIValue[iIdx]);
      
      m_lbAnalogValue.AddString(szItemString);
      
      sprintf(szItemString, "Ch%d : 0x%02x", iIdx, byAIChStatus[iIdx]);
      
      m_lbChStatus.AddString(szItemString);
    }
  }
}
